<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>m17n ライブラリ: 構造体 MFLTFont</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- 作成： Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'検索');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>メインページ</span></a></li>
      <li><a href="pages.html"><span>関連ページ</span></a></li>
      <li><a href="modules.html"><span>モジュール</span></a></li>
      <li class="current"><a href="annotated.html"><span>データ構造</span></a></li>
      <li><a href="files.html"><span>ファイル</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="検索" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="annotated.html"><span>データ構造</span></a></li>
      <li><a href="classes.html"><span>データ構造索引</span></a></li>
      <li><a href="functions.html"><span>データフィールド</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>構造体 MFLTFont<br/>
<small>
[<a class="el" href="group__m17nFLT.html">FLT API</a>]</small>
</h1><!-- doxytag: class="MFLTFont" -->
<p>FLT ドライバが使うフォントの型.  
<a href="#_details">[詳細]</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>変数</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMFLTFont.html#a4ee5ae21387ac0a308d325c2803ce38d">family</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMFLTFont.html#a4f5da0ed80dcff1a9518f8ea538dc805">x_ppem</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMFLTFont.html#ad645f26ac88930e973a637163c4cfae3">y_ppem</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMFLTFont.html#a0be91be8feeb8e0506011cb6a8794032">get_glyph_id</a> )(struct _MFLTFont *font, <a class="el" href="structMFLTGlyphString.html">MFLTGlyphString</a> *gstring, int from, int to)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMFLTFont.html#a0c12c56b74101919f49cc396edb9c4fb">get_metrics</a> )(struct _MFLTFont *font, <a class="el" href="structMFLTGlyphString.html">MFLTGlyphString</a> *gstring, int from, int to)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMFLTFont.html#ab700eef1e5f6c36245e810192264c8c0">check_otf</a> )(struct _MFLTFont *font, <a class="el" href="structMFLTOtfSpec.html">MFLTOtfSpec</a> *spec)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMFLTFont.html#a526e63af6e82feb162dba9b8ba1b7219">drive_otf</a> )(struct _MFLTFont *font, <a class="el" href="structMFLTOtfSpec.html">MFLTOtfSpec</a> *spec, <a class="el" href="structMFLTGlyphString.html">MFLTGlyphString</a> *in, int from, int to, <a class="el" href="structMFLTGlyphString.html">MFLTGlyphString</a> *out, <a class="el" href="structMFLTGlyphAdjustment.html">MFLTGlyphAdjustment</a> *adjustment)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMFLTFont.html#a246902fe3b4b6a918a51daa05051a6ed">internal</a></td></tr>
</table>
<hr/><a name="_details"></a><h2>説明</h2>
<p>FLT ドライバが使うフォントの型. </p>
<p>型 <a class="el" href="structMFLTFont.html" title="FLT ドライバが使うフォントの型.">MFLTFont</a> は、FLTドライバが使うフォントに関する情報を格納するた めの構造体である。通常アプリケーションは最初の要素が <a class="el" href="structMFLTFont.html" title="FLT ドライバが使うフォントの型.">MFLTFont</a> で、 残りの要素にcallback関数が利用するフォント情報を持った、より大きな 構造体を用意し、それを <a class="el" href="structMFLTFont.html" title="FLT ドライバが使うフォントの型.">MFLTFont</a> に coerce して mflt の各関数に渡す。 各callback関数は <a class="el" href="structMFLTFont.html" title="FLT ドライバが使うフォントの型.">MFLTFont</a> を元の構造体に coerce し直すことができる ことが保証されている。 </p>
<hr/><h2>構造体</h2>
<a class="anchor" id="a4ee5ae21387ac0a308d325c2803ce38d"></a><!-- doxytag: member="MFLTFont::family" ref="a4ee5ae21387ac0a308d325c2803ce38d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="structMFLTFont.html#a4ee5ae21387ac0a308d325c2803ce38d">MFLTFont::family</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>フォントのファミリー名。フォントに適した FLTを探す際に重要でな い場合 (たとえば OpenTypeフォントの場合など) は、<a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="&quot;nil&quot; を名前として持つシンボル.">Mnil</a> でよい。 </p>

</div>
</div>
<a class="anchor" id="a4f5da0ed80dcff1a9518f8ea538dc805"></a><!-- doxytag: member="MFLTFont::x_ppem" ref="a4f5da0ed80dcff1a9518f8ea538dc805" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMFLTFont.html#a4f5da0ed80dcff1a9518f8ea538dc805">MFLTFont::x_ppem</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>フォントの水平サイズを pixels per EM で表現したもの。 </p>

</div>
</div>
<a class="anchor" id="ad645f26ac88930e973a637163c4cfae3"></a><!-- doxytag: member="MFLTFont::y_ppem" ref="ad645f26ac88930e973a637163c4cfae3" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMFLTFont.html#ad645f26ac88930e973a637163c4cfae3">MFLTFont::y_ppem</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>フォントの垂直サイズを pixels per EM で表現したもの。 </p>

</div>
</div>
<a class="anchor" id="a0be91be8feeb8e0506011cb6a8794032"></a><!-- doxytag: member="MFLTFont::get_glyph_id" ref="a0be91be8feeb8e0506011cb6a8794032" args=")(struct _MFLTFont *font, MFLTGlyphString *gstring, int from, int to)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int(* <a class="el" href="structMFLTFont.html#a0be91be8feeb8e0506011cb6a8794032">MFLTFont::get_glyph_id</a>)(struct _MFLTFont *font, <a class="el" href="structMFLTGlyphString.html">MFLTGlyphString</a> *gstring, int from, int to)</td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>GSTRING 内の FROM から TO 直前までの各グリフに対応するグリフ IDを取得するための callback 関数。もしあるグリフのメンバー &lt;encoded&gt;がゼロならば、そのグリフのメンバー &lt;code&gt; は文字コードで ある。この関数はその文字コードを FONT のグリフ IDに変換しなくては ならない。 </p>

</div>
</div>
<a class="anchor" id="a0c12c56b74101919f49cc396edb9c4fb"></a><!-- doxytag: member="MFLTFont::get_metrics" ref="a0c12c56b74101919f49cc396edb9c4fb" args=")(struct _MFLTFont *font, MFLTGlyphString *gstring, int from, int to)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int(* <a class="el" href="structMFLTFont.html#a0c12c56b74101919f49cc396edb9c4fb">MFLTFont::get_metrics</a>)(struct _MFLTFont *font, <a class="el" href="structMFLTGlyphString.html">MFLTGlyphString</a> *gstring, int from, int to)</td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>GSTRING 内の FROM から TO直前までの各グリフに対応するメトリッ クを取得するための callback 関数。もしあるグリフのメンバー &lt;measured&gt;がゼロならば、この関数はそのグリフのメンバー &lt;xadv&gt;, &lt;yadv&gt;, &lt;ascent&gt;, &lt;descent&gt;, &lt;lbearing&gt;, および &lt;rbearing&gt;をセッ トしなければならない。 </p>

</div>
</div>
<a class="anchor" id="ab700eef1e5f6c36245e810192264c8c0"></a><!-- doxytag: member="MFLTFont::check_otf" ref="ab700eef1e5f6c36245e810192264c8c0" args=")(struct _MFLTFont *font, MFLTOtfSpec *spec)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int(* <a class="el" href="structMFLTFont.html#ab700eef1e5f6c36245e810192264c8c0">MFLTFont::check_otf</a>)(struct _MFLTFont *font, <a class="el" href="structMFLTOtfSpec.html">MFLTOtfSpec</a> *spec)</td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>フォントがある特定のスクリプト/言語に対する GSUB/GPOS OpenTypeフィーチャーを持つか否かを調べる callback 関数。この関数 はフォントがSPEC を満たすときは 1 を、そうでないときは 0を返さな ければならない。フォントが OpenType テーブルを持たないときはNULL でなければならない。 </p>

</div>
</div>
<a class="anchor" id="a526e63af6e82feb162dba9b8ba1b7219"></a><!-- doxytag: member="MFLTFont::drive_otf" ref="a526e63af6e82feb162dba9b8ba1b7219" args=")(struct _MFLTFont *font, MFLTOtfSpec *spec, MFLTGlyphString *in, int from, int to, MFLTGlyphString *out, MFLTGlyphAdjustment *adjustment)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int(* <a class="el" href="structMFLTFont.html#a526e63af6e82feb162dba9b8ba1b7219">MFLTFont::drive_otf</a>)(struct _MFLTFont *font, <a class="el" href="structMFLTOtfSpec.html">MFLTOtfSpec</a> *spec, <a class="el" href="structMFLTGlyphString.html">MFLTGlyphString</a> *in, int from, int to, <a class="el" href="structMFLTGlyphString.html">MFLTGlyphString</a> *out, <a class="el" href="structMFLTGlyphAdjustment.html">MFLTGlyphAdjustment</a> *adjustment)</td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>IN 内の FROM から TO 直前までの各グリフに SPEC内の各 OpenType フィーチャーを適用するための callback 関数。適用結果のグリフ列は OUT の末尾に追加される。OUT が短か過ぎて結果を追加し切れない場合 は -2 を返さなくてはならない。フォントが OpenType テーブルを持た ない場合は NULLでなければならない。 </p>

</div>
</div>
<a class="anchor" id="a246902fe3b4b6a918a51daa05051a6ed"></a><!-- doxytag: member="MFLTFont::internal" ref="a246902fe3b4b6a918a51daa05051a6ed" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="structMFLTFont.html#a246902fe3b4b6a918a51daa05051a6ed">MFLTFont::internal</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>m17n-lib の内部作業用。NULL に初値化される。 </p>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>全て</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>データ構造</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>ファイル</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>関数</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>変数</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>型定義</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>列挙型</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>列挙型の値</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>マクロ定義</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<!-- -*- coding: utf-8; -*- -->
<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-ja/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
